Leetcode kSum問題

kSum 泛指一類問題碉熄,例如 leetcode 第1題 2 Sum腹忽,leetcode 第15題 3 Sum饰序,leetcode 第18題 4 Sum

我們先一題一題來看届宠,然后總結出這一類題目的解題套路。

2Sum(leetcode 第1題)

問題

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

兩層for循環(huán)解法(O(N^2))

public int[] twoSum(int[] nums, int target) {
    int[] res = new int[2];
    for (int i = 0; i < nums.length; i++) {
        for (int j = i + 1; j < nums.length; j++) {
            if (nums[i] + nums[j] == target) {
                res[0] = i;
                res[1] = j;
                return res;
            }
        }
    }
    return res;
}

時間復雜度:O(N^2)

這種解法最簡單直觀乘粒,但是效率也是最低的豌注。如果提交的話無法通過所有 test case,肯定會超時灯萍。

排序+two pointers(O(NlogN))

先排序轧铁,然后再使用 two pointers:

public int[] twoSum(int[] nums, int target) {
    Arrays.sort(nums);
    int i = 0, j = nums.length - 1;
    int[] res = new int[2];
    while (i < j) {
        if (nums[i] + nums[j] == target) {
            res[0] = i;
            res[1] = j;
            break;
        } else if (nums[i] + nums[j] < target) {
            i++;
        } else {
            j--;
        }
    }
    return res;
}

時間復雜度:O(Nlog(N)) + O(N),最后復雜度為O(Nlog(N))

HashMap一遍遍歷(O(N))

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        map.put(nums[i], i);
    }
    int j = 0, k = 0;
    for (int i = 0; i < nums.length; i++) {
        int left = target - nums[i];
        if (map.containsKey(left) && i != map.get(left)) {
            j = i;
            k = map.get(left);
            break;
        }
    }
    int[] res = new int[2];
    res[0] = j;
    res[1] = k;
    return res;
}

時間復雜度:O(N)

3Sum(leetcode 第5題)

問題

Given an array nums of n integers, are there elements a, b, c in nums such that a + b + c = 0? Find all unique triplets in the array which gives the sum of zero.

Note:

The solution set must not contain duplicate triplets.

Example:

Given array nums = [-1, 0, 1, 2, -1, -4],

A solution set is:
[
  [-1, 0, 1],
  [-1, -1, 2]
]

排序+ two pointers

3Sum 和 2Sum 類似旦棉,前面介紹的 2Sum 的前兩種解法對 3Sum一樣有效齿风。第一種解法通過三層 for 循環(huán)肯定會超時。因此我們還是先排序绑洛,然后再用 two pointers 來解題:

public List<List<Integer>> threeSum(int[] nums) {
    if (nums == null || nums.length < 3) {
        return new ArrayList<>();
    }
    List<List<Integer>> ret = new ArrayList<>();
    Arrays.sort(nums);
    for (int i = 0; i < nums.length - 2; i++) {
        int num = nums[i];
        if (i > 0 && nums[i] == nums[i - 1]) {
            continue;
        }
        bSearch(nums, i + 1, nums.length - 1, -num, ret, i);
    }
    return ret;
}

private void bSearch(int[] nums, int start, int end, int targetTotal, List<List<Integer>> ret, int index) {
    int i = start, j = end;
    while (i < j) {
        if (targetTotal == nums[i] + nums[j]) {
            List<Integer> oneShot = new ArrayList<>();
            oneShot.add(nums[index]);
            oneShot.add(nums[i]);
            oneShot.add(nums[j]);
            ret.add(oneShot);
            // 題目要求結果返回的 triple 都是唯一的救斑,因此這里需要跳過前后相同的元素
            while (i < j && nums[i] == nums[i + 1]) {
                i++;
            }
            while (i < j && nums[j] == nums[j - 1]) {
                j--;
            }
            i++;
            j--;
        } else if (nums[i] + nums[j] > targetTotal) {
            j--;
        } else {
            i++;
        }
    }
}

時間復雜度:O(NlogN) + O(N2),最終復雜度為O(N2)

4Sum(leetcode 第18題)

問題

Given an array nums of n integers and an integer target, are there elements a, b, c, and d in nums such that a + b + c + d = target? Find all unique quadruplets in the array which gives the sum of target.

Note:

The solution set must not contain duplicate quadruplets.

Example:

Given array nums = [1, 0, -1, 0, -2, 2], and target = 0.

A solution set is:
[
  [-1,  0, 0, 1],
  [-2, -1, 1, 2],
  [-2,  0, 0, 2]
]

分析

在解 3Sum 題的時候我們先固定了一個數(shù)num真屯,然后再在剩余的數(shù)組元素中利用 two pointers 方法尋找和為 target - num的兩個數(shù)脸候。

歸納分析,我們可以將 kSum 一類的問題的解法分為兩個步驟:

  1. 將 kSum 問題轉換成 2Sum 問題
  2. 解決 2Sum 問題

給出 kSum 一類問題的一般解法如下:

/**
 * All kSum problem can be divided to two parts:
 * 1: convert kSum to 2Sum problem;
 * 2: solve the 2Sum problem;
 *
 * @param k
 * @param index
 * @param nums
 * @param target
 * @return
 */
private List<List<Integer>> kSum(int k, int index, int[] nums, int target) {
    List<List<Integer>> res = new ArrayList<>();
    int len = nums.length;
    if (k == 2) {
        // 使用 two pointers 解決 2Sum 問題
        int left = index, right = len - 1;
        while (left < right) {
            int sum = nums[left] + nums[right];
            if (sum == target) {
                List<Integer> path = new ArrayList<>();
                path.add(nums[left]);
                path.add(nums[right]);
                res.add(path);
                // skip the duplicates
                while (left < right && nums[left] == nums[left + 1]) {
                    left++;
                }
                while (left < right && nums[right] == nums[right - 1]) {
                    right--;
                }
                left++;
                right--;
            } else if (sum > target) {
                right--;
            } else {
                left++;
            }
        }
    } else {
        // 將 kSum 問題轉換為 2Sum 問題
        for (int i = index; i < len - k + 1; i++) {
            // 跳過重復的元素
            if (i > index && nums[i] == nums[i - 1]) {
                continue;
            }
            // 固定一個元素绑蔫,然后遞歸
            List<List<Integer>> kSubtractOneSum = kSum(k - 1, i + 1, nums, target - nums[i]);
            if (kSubtractOneSum != null) {
                for (List<Integer> path : kSubtractOneSum) {
                    path.add(0, nums[i]); // 將固定的元素加入路徑中
                }
                res.addAll(kSubtractOneSum);
            }
        }
    }
    return res;
}

解決了 kSum問題之后运沦,4Sum 問題的解法就很簡單了:

public List<List<Integer>> fourSum(int[] nums, int target) {
    if (nums == null || nums.length < 4) {
        return new ArrayList<>();
    }
    Arrays.sort(nums);
    return kSum(4, 0, nums, target);
}

時間復雜度:O(N^3)。

最后編輯于
?著作權歸作者所有,轉載或內容合作請聯(lián)系作者
  • 序言:七十年代末晾匠,一起剝皮案震驚了整個濱河市茶袒,隨后出現(xiàn)的幾起案子,更是在濱河造成了極大的恐慌凉馆,老刑警劉巖薪寓,帶你破解...
    沈念sama閱讀 206,378評論 6 481
  • 序言:濱河連續(xù)發(fā)生了三起死亡事件,死亡現(xiàn)場離奇詭異澜共,居然都是意外死亡向叉,警方通過查閱死者的電腦和手機,發(fā)現(xiàn)死者居然都...
    沈念sama閱讀 88,356評論 2 382
  • 文/潘曉璐 我一進店門嗦董,熙熙樓的掌柜王于貴愁眉苦臉地迎上來母谎,“玉大人,你說我怎么就攤上這事京革∑婊剑” “怎么了幸斥?”我有些...
    開封第一講書人閱讀 152,702評論 0 342
  • 文/不壞的土叔 我叫張陵,是天一觀的道長咬扇。 經(jīng)常有香客問我甲葬,道長,這世上最難降的妖魔是什么懈贺? 我笑而不...
    開封第一講書人閱讀 55,259評論 1 279
  • 正文 為了忘掉前任经窖,我火速辦了婚禮,結果婚禮上梭灿,老公的妹妹穿的比我還像新娘画侣。我一直安慰自己,他們只是感情好堡妒,可當我...
    茶點故事閱讀 64,263評論 5 371
  • 文/花漫 我一把揭開白布配乱。 她就那樣靜靜地躺著,像睡著了一般皮迟。 火紅的嫁衣襯著肌膚如雪宪卿。 梳的紋絲不亂的頭發(fā)上,一...
    開封第一講書人閱讀 49,036評論 1 285
  • 那天万栅,我揣著相機與錄音佑钾,去河邊找鬼。 笑死烦粒,一個胖子當著我的面吹牛休溶,可吹牛的內容都是我干的。 我是一名探鬼主播扰她,決...
    沈念sama閱讀 38,349評論 3 400
  • 文/蒼蘭香墨 我猛地睜開眼兽掰,長吁一口氣:“原來是場噩夢啊……” “哼!你這毒婦竟也來了徒役?” 一聲冷哼從身側響起孽尽,我...
    開封第一講書人閱讀 36,979評論 0 259
  • 序言:老撾萬榮一對情侶失蹤,失蹤者是張志新(化名)和其女友劉穎忧勿,沒想到半個月后杉女,有當?shù)厝嗽跇淞掷锇l(fā)現(xiàn)了一具尸體,經(jīng)...
    沈念sama閱讀 43,469評論 1 300
  • 正文 獨居荒郊野嶺守林人離奇死亡鸳吸,尸身上長有42處帶血的膿包…… 初始之章·張勛 以下內容為張勛視角 年9月15日...
    茶點故事閱讀 35,938評論 2 323
  • 正文 我和宋清朗相戀三年熏挎,在試婚紗的時候發(fā)現(xiàn)自己被綠了。 大學時的朋友給我發(fā)了我未婚夫和他白月光在一起吃飯的照片晌砾。...
    茶點故事閱讀 38,059評論 1 333
  • 序言:一個原本活蹦亂跳的男人離奇死亡坎拐,死狀恐怖,靈堂內的尸體忽然破棺而出,到底是詐尸還是另有隱情哼勇,我是刑警寧澤都伪,帶...
    沈念sama閱讀 33,703評論 4 323
  • 正文 年R本政府宣布,位于F島的核電站积担,受9級特大地震影響院溺,放射性物質發(fā)生泄漏。R本人自食惡果不足惜磅轻,卻給世界環(huán)境...
    茶點故事閱讀 39,257評論 3 307
  • 文/蒙蒙 一、第九天 我趴在偏房一處隱蔽的房頂上張望逐虚。 院中可真熱鬧聋溜,春花似錦、人聲如沸叭爱。這莊子的主人今日做“春日...
    開封第一講書人閱讀 30,262評論 0 19
  • 文/蒼蘭香墨 我抬頭看了看天上的太陽买雾。三九已至把曼,卻和暖如春,著一層夾襖步出監(jiān)牢的瞬間漓穿,已是汗流浹背嗤军。 一陣腳步聲響...
    開封第一講書人閱讀 31,485評論 1 262
  • 我被黑心中介騙來泰國打工, 沒想到剛下飛機就差點兒被人妖公主榨干…… 1. 我叫王不留晃危,地道東北人叙赚。 一個月前我還...
    沈念sama閱讀 45,501評論 2 354
  • 正文 我出身青樓,卻偏偏與公主長得像僚饭,于是被迫代替她去往敵國和親震叮。 傳聞我的和親對象是個殘疾皇子,可洞房花燭夜當晚...
    茶點故事閱讀 42,792評論 2 345